/*
Code automatically generated by asn1scc tool
*/
#include <limits.h>
#include <string.h>
#include <math.h>
#include "Flash.h"

#if !defined(_MSC_VER) || _MSC_VER >= 1800
void FlashSetup_Initialize(FlashSetup* pVal)
{
    *pVal = (FlashSetup) {
    .duration = 0,
    .strength = 0
};
}
#endif

 
flag FlashSetup_IsConstraintValid(const FlashSetup* pVal, int* pErrCode)
{
    
    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = ShutterTime_IsConstraintValid(&pVal->duration, pErrCode);
	if (ret) {
	    ret = FlashStrength_IsConstraintValid(&pVal->strength, pErrCode);
	
	}

	return ret;
}

flag FlashSetup_Encode(const FlashSetup* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
    
	ret = bCheckConstraints ? FlashSetup_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    /*Encode duration */
	    ret = ShutterTime_Encode(&pVal->duration, pBitStrm, pErrCode, FALSE);
	    if (ret) {
	        /*Encode strength */
	        ret = FlashStrength_Encode(&pVal->strength, pBitStrm, pErrCode, FALSE);
	    
	    }
    }

	return ret;
}

flag FlashSetup_Decode(FlashSetup* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;

	/*Decode duration */
	ret = ShutterTime_Decode(&pVal->duration, pBitStrm, pErrCode);
	if (ret) {
	    /*Decode strength */
	    ret = FlashStrength_Decode(&pVal->strength, pBitStrm, pErrCode);
	
	}


	return ret;
}

